import * as angular from 'angular';

class AvailableContentService {
    Authorization: string;
    /*@ngInject*/
    constructor(
        private $q,
        private OpenGraphService,
        private DocumentService,
    ) {

    } 

    getContentPromise = (query) => {
        return this.$q((resolve, reject) => {
            this.DocumentService.getExistingDocuments(query.documentServiceQuery)
                .then(existingDocuments => {
                    if (existingDocuments && existingDocuments[0]) {
                        let existingDocument = existingDocuments[0]
                        let wasIndexed = true
                        return { existingDocument, wasIndexed }
                    }
                    let scrapedUrl = this.OpenGraphService.scrapeUrls(query.url)
                    let wasScraped = true;
                    return { scrapedUrl, wasScraped }
                })
                .then((existingOrScrapedDocument) => {
                    resolve(existingOrScrapedDocument)
                })
                .catch(reject);
        })
    }

    getAvailableContent = (queries) => {
       
        let getContentPromises = queries.map((query) => {
            return this.getContentPromise(query)
        })

        return this.$q.all(getContentPromises)
    }
}

export default AvailableContentService;
